Last updated

API / geotoolkit / map / sources / Vector / Vector

Class: Vector

sources.Vector.Vector

Vector source that allows user to get features from remote resource

Hierarchy

Table of contents

Constructors
Methods
Css Properties
Name Type Description
systemstringInitial data coordinate system
urlstringData server url

Contents

Constructors

new Vector(options)

new Vector(options?)

Creates vector source

Parameters

Name Type Description
Optional optionsOptionsoptions

Overrides

AbstractSource.constructor

Methods

addFeatures

addFeatures(features, needTransform?): Vector

Notifies source to add features.

Parameters

Name Type Description
featuresAbstractFeature[]features to add
Optional needTransformbooleantrue if features should be transformed to the map coordinates

Returns

Vector

this


clear

clear(): Vector

Clears all the data.

Returns

Vector

this

Inherited from

AbstractSource.clear


clearFeatures

clearFeatures(): Vector

Notifies source to remove all features added.

Returns

Vector

this


dispose

dispose(): void

Disposes this source, once disposed it should not be used anymore.

Returns

void

Inherited from

AbstractSource.dispose


getClassName

getClassName(): string

Returns

string

Inherited from

AbstractSource.getClassName


getCopyright

getCopyright(): string

Returns copyright information.

Returns

string

Inherited from

AbstractSource.getCopyright


getDataLoader

Protected getDataLoader(): AbstractLoader

Returns server data loader (if exists)

Returns

AbstractLoader

Inherited from

AbstractSource.getDataLoader


getInitialCoordinateSystem

getInitialCoordinateSystem(): AbstractSystem

Gets current data initial coordinate system.

Returns

AbstractSystem

Inherited from

AbstractSource.getInitialCoordinateSystem


getMapCoordinateSystem

getMapCoordinateSystem(): AbstractSystem

Gets current map coordinate system.

Returns

AbstractSystem

Inherited from

AbstractSource.getMapCoordinateSystem


getModelLimits

getModelLimits(): Rect

Returns the current data model limits (presumably loaded from the server if it's settled)

Returns

Rect

Inherited from

AbstractSource.getModelLimits


getProperties

getProperties(): OptionsOut

Returns properties

Returns

OptionsOut

properties

Inherited from

AbstractSource.getProperties


getRequestResolution

getRequestResolution(): number

Gets the grid size for layer partitioning that is used for server requests

Returns

number


getServerData

getServerData(): JSONObject | XMLDocument

Returns server data loaded from the server Should be used asynchronically after loadServerData() method is called

Returns

JSONObject | XMLDocument

Inherited from

AbstractSource.getServerData


getServerURL

getServerURL(): string | string[]

Gets the server url that is currently used for requests

Returns

string | string[]

server url

Inherited from

AbstractSource.getServerURL


getTransformerFromMap

getTransformerFromMap(): Transformer

Gets transformer to transform data from map coordinate system

Returns

Transformer

Inherited from

AbstractSource.getTransformerFromMap


getTransformerToMap

getTransformerToMap(): Transformer

Gets transformer to transform data to map coordinate system

Returns

Transformer

Inherited from

AbstractSource.getTransformerToMap


getUniqueField

getUniqueField(): string

Gets the unique identifier for the dataset

Returns

string

field


hasEventListener

hasEventListener(type, callback?): boolean

Check if a list of event listeners for this type contains this listener

Parameters

Name Type Description
typestringtype of event or property
Optional callbackFunctionto be called, if null, check if any callback is registered

Returns

boolean

Inherited from

AbstractSource.hasEventListener


initLoader

Protected initLoader(loader?): Vector

Initializes the loader provided

Parameters

Name Type Description
Optional loaderAbstractLoaderloader to use

Returns

Vector

this

Inherited from

AbstractSource.initLoader


isDataLoaded

isDataLoaded(): boolean

Returns true if server data is already loaded (or no loader provided)

Returns

boolean

Inherited from

AbstractSource.isDataLoaded


isDataReady

isDataReady(): boolean

Checks if source (current visible) data is loaded and ready to be rendered

Returns

boolean

Inherited from

AbstractSource.isDataReady


isDisposed

isDisposed(): boolean

Returns whether this object has been disposed

Returns

boolean

Inherited from

AbstractSource.isDisposed


isLoading

isLoading(): boolean

Checks if some of the requests haven't been finished yet. Returns true if some data is loading, false otherwise.

Returns

boolean

Inherited from

AbstractSource.isLoading


isSilent

isSilent(): boolean

Return true if the event dispatcher doesn't notify any events

Returns

boolean

Inherited from

AbstractSource.isSilent


loadServerData

loadServerData(): Promise<Vector>

Returns promise that is loaded when server settings are ready to process

Returns

Promise<Vector>

Inherited from

AbstractSource.loadServerData


loadSourceData

loadSourceData(): Promise<AbstractSource>

Returns promise that is resolving when data are ready to process

Returns

Promise<AbstractSource>

Inherited from

AbstractSource.loadSourceData


notify

notify<E>(type, source, args?): Vector

Notify listeners

Type parameters

NameType
Eextends string

Parameters

Name Type Description
typeEevent types
sourceVectorof the event
Optional argsEventMap[E]arguments of the event

Returns

Vector

this

Overrides

AbstractSource.notify


off

off<E>(type?, callback?): Vector

Detach listener on event. Calling .off() with no arguments removes all attached listeners. Calling .off(type) with no callback removes all attached listeners for specific type.

Type parameters

NameType
Eextends string

Parameters

Name Type Description
Optional typeEtype of the event
Optional callback(eventType: E, sender: Vector, args: EventMap[E]) => voidfunction to be called

Returns

Vector

this

Overrides

AbstractSource.off


on

on<E>(type, callback): Vector

Attach listener on event that will be called whenever the specified event is delivered to the target

If the callback function is already in the list of event listeners for this target, the function is not added a second time.

If a particular anonymous function is in the list of event listeners registered for a certain target, and then later in the code, an identical anonymous function is given in an "on" call, the second function will also be added to the list of event listeners for that target.

Type parameters

NameType
Eextends string

Parameters

Name Type Description
typeEtype of event or property
callback(eventType: E, sender: Vector, args: EventMap[E]) => voidto be called

Returns

Vector

this

Overrides

AbstractSource.on


queryFeatures

queryFeatures(bbox, layer): Vector

Sends a request for features in given bounding box.

Parameters

Name Type Description
bboxRectbounding box for features
layerAbstractFeatureLayerlayer requesting

Returns

Vector

this


removeFeature

removeFeature(feature): Vector

Notifies source to remove feature.

Parameters

Name Type Description
featureAbstractFeaturefeature to remove

Returns

Vector

this


requestData

requestData(resource): void

Requests data from the resource and parses the response

Parameters

Name Type Description
resourcestringresource url for request

Returns

void


resetLastQueryParams

Protected resetLastQueryParams(): Vector

Resets saved last queried limits and layer

Returns

Vector

this

Inherited from

AbstractSource.resetLastQueryParams


setDataReady

Protected setDataReady(isReady, err?): Vector

Sets source (current visible) data ready/not ready, changes the corresponding promise

Parameters

Name Type Description
isReadybooleantrue if source data was loaded, false if it needs to be reset
Optional errErrordata loading error (if exists)

Returns

Vector

this

Inherited from

AbstractSource.setDataReady


setInitialCoordinateSystem

setInitialCoordinateSystem(system): Vector

Sets the data initial coordinate system.

Parameters

Name Type Description
systemstring | AbstractSysteminitial coordinate system

Returns

Vector

this

Inherited from

AbstractSource.setInitialCoordinateSystem


setMapCoordinateSystem

setMapCoordinateSystem(system): Vector

Sets map coordinate system.

Parameters

Name Type Description
systemstring | AbstractSystemmap coordinate system

Returns

Vector

this

Inherited from

AbstractSource.setMapCoordinateSystem


setProperties

setProperties(properties?): Vector

Sets properties

Parameters

Name Type Description
Optional propertiesOptionsproperties

Returns

Vector

this

Inherited from

AbstractSource.setProperties


setQueryParameter

setQueryParameter(param, value?): Vector

Sets custom query parameter to add to the data requests

Parameters

Name Type Description
paramstring | Record<string, string | number>parameter name or custom parameters object (in name -> value format)
Optional valuestring | numberparameter value

Returns

Vector

this

Inherited from

AbstractSource.setQueryParameter


setRequestResolution

setRequestResolution(resolution): Vector

Sets the grid size for layer partitioning that is used for server requests

Parameters

Name Type Description
resolutionnumbergrid size

Returns

Vector

this


setServerURL

setServerURL(url): Vector

Sets the server url to use for requesting

Parameters

Name Type Description
urlstring | string[]server url

Returns

Vector

this

Inherited from

AbstractSource.setServerURL


setSilent

setSilent(bool): Vector

Set silent mode

Parameters

Name Type Description
boolbooleanflag to enable silent mode

Returns

Vector

this

Inherited from

AbstractSource.setSilent


setUniqueField

setUniqueField(field): Vector

Sets the unique identifier for the features

Parameters

Name Type Description
fieldstringunique identifier

Returns

Vector

this


update

update(): Vector

Aborts all the sent requests, resends the last one

Returns

Vector

this

Inherited from

AbstractSource.update


getClassName

Static getClassName(): string

Returns

string

Inherited from

AbstractSource.getClassName